// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.28.0

package dbq

import (
	"database/sql/driver"
	"fmt"

	"github.com/jackc/pgx/v5/pgtype"
)

type PostState string

const (
	PostStateDraft     PostState = "draft"
	PostStatePublished PostState = "published"
)

func (e *PostState) Scan(src interface{}) error {
	switch s := src.(type) {
	case []byte:
		*e = PostState(s)
	case string:
		*e = PostState(s)
	default:
		return fmt.Errorf("unsupported scan type for PostState: %T", src)
	}
	return nil
}

type NullPostState struct {
	PostState PostState
	Valid     bool // Valid is true if PostState is not NULL
}

// Scan implements the Scanner interface.
func (ns *NullPostState) Scan(value interface{}) error {
	if value == nil {
		ns.PostState, ns.Valid = "", false
		return nil
	}
	ns.Valid = true
	return ns.PostState.Scan(value)
}

// Value implements the driver Valuer interface.
func (ns NullPostState) Value() (driver.Value, error) {
	if !ns.Valid {
		return nil, nil
	}
	return string(ns.PostState), nil
}

type Post struct {
	ID        int64
	SiteID    int64
	Title     pgtype.Text
	Body      string
	State     PostState
	Props     []byte
	PostDate  pgtype.Timestamptz
	CreatedAt pgtype.Timestamp
}

type Site struct {
	ID    int64
	Name  string
	Title string
	Url   string
	Theme string
	Props []byte
}
